Package: io.vertx.groovy.core.streams

## [Groovy] Class WriteStreamImpl<T>

- io.vertx.groovy.core.streams.WriteStreamImpl

- All Implemented Interfaces and Traits:
    WriteStream

      @groovy.transform.CompileStatic
      class WriteStreamImpl
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and description
    `WriteStreamImpl (java.lang.Object delegate)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `WriteStream<T>` | `drainHandler(io.vertx.core.Handler<java.lang.Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Ends the stream.
    `void` | `end(T t)` Same as WriteStream.end but writes some data to the stream before ending.
    `WriteStream<T>` | `exceptionHandler(io.vertx.core.Handler<java.lang.Throwable> handler)` Set an exception handler on the write stream.
    `java.lang.Object` | `getDelegate()`
    `WriteStream<T>` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `WriteStream<T>` | `write(T data)` Write some data to the stream.
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using WriteStream.setWriteQueueMaxSize

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Constructor Detail

    - #### WriteStreamImpl(java.lang.Object delegate)

  - ### Method Detail

    - #### WriteStream<T> drainHandler(io.vertx.core.Handler<java.lang.Void> handler)

      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See Pump for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.
      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `handler` - the handler

    - #### void end()

      Ends the stream.

      Once the stream has ended, it cannot be used any more.

    - #### void end(T t)

      Same as WriteStream.end but writes some data to the stream before ending.

      Parameters:
        t

    - #### WriteStream<T> exceptionHandler(io.vertx.core.Handler<java.lang.Throwable> handler)

      Set an exception handler on the write stream.

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `handler` - the exception handler

    - #### java.lang.Object getDelegate()

    - #### WriteStream<T> setWriteQueueMaxSize(int maxSize)

      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a NetSocket, the number of Message for a MessageProducer, etc...
      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `maxSize` - the max size of the write stream

    - #### WriteStream<T> write(T data)

      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the WriteStream.writeQueueFull method before writing. This is done automatically if using a Pump.

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `data` - the data to write

    - #### boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using WriteStream.setWriteQueueMaxSize

      Returns:
        true if write queue is full